%Questo agente  in grado di muoversi dentro alla stanza e pulire le zone dove passa,
%evitando muri, oggetti fissi, altri pulitori (se presenti) ed evitando di ripassare
%su di una zona che risulti gi pulita (qualora questo sia possibile).

:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(ingresso).
ingresso :-
	enter_context([agent_id(pulitore_1)]),
	text_from_file('specification\pulitori.pl',X),
	mappa ? set_spec(X),
	stanza ? rd(porta(A,B)),
	(mappa ? rdp(posizione_2(Z,K)),!,attendi_spostamento,
	mappa ? out(posizione_1(A,B));
	mappa ? out(posizione_1(A,B))),
	write(posizione_1(A,B)),nl,
	mappa ? out(pul_1(0)),
	Verso=0,
	movimento(Verso),
	mappa ? out(fine_1),
	write(fine_1),nl,
	exit_context.

%Verso  una variabile che indica in che direzione si deve effettuare il movimento.
%Verso=0 => inc.Y, Verso=1 => inc.X, Verso=2 => dec.Y, Verso=3 => dec.X)
%l'agente si muove lungo la direzione Verso a meno di ostacoli
movimento(Verso) :-
	mappa ? rd(posizione_1(X,Y)),
	(Verso==0,!,X1=X,Y1 is Y + 1;
	Verso==1,!,X1 is X + 1,Y1=Y;
	Verso==2,!,X1=X,Y1 is Y - 1;
	Verso==3,!,X1 is X - 1,Y1=Y),
	ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso),
	(Ost==0,!,
	mappa ? out(pulito_da_1(X,Y)),
	stanza ? out(pulito(X,Y)),
	mappa ? in(posizione_1(X,Y)),
	mappa ? out(posizione_1(X1,Y1)),
	write(posizione_1(X1,Y1)),nl;
	Ost==1),
	(mappa ? inp(stop_1),!;movimento(Nuovo_Verso)).

%ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso). X1,Y1=coordinate nelle quali si vuole verificare
%la presenza di ostacoli, Verso=verso di percorrenza, Ost indica la presenza o l'assenza
%di un ostacolo. (R=1 => ostacolo presente)
ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso) :-
	((stanza ? rdp(oggetto_fisso(X1,Y1)),!,mappa ? out(oggetto_fisso_1(X1,Y1));
	stanza ? inp(muro(X1,Y1)),!,mappa ? out(oggetto_fisso_1(X1,Y1));
	altri_pulitori(X1,Y1);
	controllo_pulito(X1,Y1,Pulito),Pulito>0,Pulito<4),!,
	gira(Verso,Nuovo_Verso),
	Ost=1;
	Ost=0,Nuovo_Verso=Verso).

%controlla la presenza di altri pulitori come ostacoli
altri_pulitori(X1,Y1):-
	(mappa ? rdp(posizione_2(X1,Y1)),!,mappa ? out(pulitore_2_in(X1,Y1));
	mappa ? rdp(posizione_SL1(X1,Y1)),!,mappa ? out(pulitore_SL1_in(X1,Y1));
	mappa ? rdp(posizione_TL1(X1,Y1)),!,mappa ? out(pulitore_TL1_in(X1,Y1));
	mappa ? rdp(posizione_TL2(X1,Y1)),!,mappa ? out(pulitore_TL2_in(X1,Y1));
	mappa ? rdp(posizione_TS(X1,Y1)),!,mappa ? out(trova_sporco_TS_in(X1,Y1))).

%permette di controllare se una zona  gi stata pulita (Pulito=1) per evitare di ripassarci
%sopra. Qual'ora anche tutte le zone circostanti siano pulite (Pulito=4) esegue una svolta
%di 90 e prosegue. 
controllo_pulito(X1,Y1,Pulito):-
	mappa ? in(pul_1(Pul)),
	(stanza ? rdp(pulito(X1,Y1)),!,
	mappa ? out(zona_gia_pulita_1(X1,Y1)),
	Pulito is Pul + 1;
	Pulito=0),
	mappa ? out(pul_1(Pulito)).

%consente la svolta a destra in presenza di ostacoli
gira(Verso,Nuovo_Verso) :-
	(Verso==0,!,Nuovo_Verso=1;
	Verso==1,!,Nuovo_Verso=2;
	Verso==2,!,Nuovo_Verso=3;
	Verso==3,!,Nuovo_Verso=0).

%consente di attendere che si liberi la zona antestante la porta
attendi_spostamento:-
	stanza ? rd(porta(X,Y)),
	mappa ? rdp(posizione_2(Z,K)),
	((X\==Z;Y\==K);attendi_spostamento).	