%Questo agente  una evoluzione dell'agente "pulitore_1" in quanto in aggiunta alle
%propriet del suddetto  in grado di verificare la presenza di sporco nelle zone adiacenti
%alla posizione da esso occupata e dirigersi in quella direzione per eliminarlo

:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(ingresso).
ingresso :-
	enter_context([agent_id(pulitore_SL1)]),
	text_from_file('specification\pulitori.pl',X),
	mappa ? set_spec(X),
	stanza ? rd(porta(A,B)),
	(mappa ? rdp(posizione_1(Z,K)),!,attendi_spostamento,
	mappa ? out(posizione_SL1(A,B));
	mappa ? out(posizione_SL1(A,B))),
	write(posizione_SL1(A,B)),nl,
	mappa ? out(pul_SL1(0)),
	Verso=0,
	ricerca_sporco(A,B,Verso,N_Verso),
	movimento(N_Verso),
	mappa ? out(fine_SL1),
	write(fine_SL1),nl,
	exit_context.

movimento(Verso) :-
	mappa ? rd(posizione_SL1(X,Y)),
	ricerca_sporco(X,Y,Verso,N_Verso),
	(N_Verso==0,!,X1=X,Y1 is Y + 1;
	N_Verso==1,!,X1 is X + 1,Y1=Y;
	N_Verso==2,!,X1=X,Y1 is Y - 1;
	N_Verso==3,!,X1 is X - 1,Y1=Y),
	ostacolo(X1,Y1,N_Verso,Ost,Nuovo_Verso),
	(Ost==0,!,
	mappa ? out(pulito_da_SL1(X,Y)),
	stanza ? out(pulito(X,Y)),
	mappa ? in(posizione_SL1(X,Y)),
	mappa ? out(posizione_SL1(X1,Y1)),
	write(posizione_SL1(X1,Y1)),nl;
	Ost==1),
	(mappa ? inp(stop_SL1),!;movimento(Nuovo_Verso)).

ostacolo(X1,Y1,N_Verso,Ost,Nuovo_Verso) :-
	((stanza ? rdp(oggetto_fisso(X1,Y1)),!,mappa ? out(oggetto_fisso_SL1(X1,Y1));
	stanza ? inp(muro(X1,Y1)),!,mappa ? out(oggetto_fisso_SL1(X1,Y1));
	altri_pulitori(X1,Y1);
	controllo_pulito(X1,Y1,Pulito),Pulito>0,Pulito<4),!,
	gira(N_Verso,Nuovo_Verso),
	Ost=1;
	Ost=0,Nuovo_Verso=N_Verso).

altri_pulitori(X1,Y1):-
	(mappa ? rdp(posizione_1(X1,Y1)),!,mappa ? out(pulitore_1_in(X1,Y1));
	mappa ? rdp(posizione_2(X1,Y1)),!,mappa ? out(pulitore_2_in(X1,Y1));
	mappa ? rdp(posizione_TL1(X1,Y1)),!,mappa ? out(pulitore_TL1_in(X1,Y1));
	mappa ? rdp(posizione_TL2(X1,Y1)),!,mappa ? out(pulitore_TL2_in(X1,Y1));
	mappa ? rdp(posizione_TS(X1,Y1)),!,mappa ? out(trova_sporco_TS_in(X1,Y1))).

controllo_pulito(X1,Y1,Pulito):-
	mappa ? in(pul_SL1(Pul)),
	(stanza ? rdp(pulito(X1,Y1)),!,
	mappa ? out(zona_gia_pulita_SL1(X1,Y1)),
	Pulito is Pul + 1;
	Pulito=0),
	mappa ? out(pul_SL1(Pulito)).

gira(N_Verso,Nuovo_Verso) :-
	(N_Verso==0,!,Nuovo_Verso=1;
	N_Verso==1,!,Nuovo_Verso=2;
	N_Verso==2,!,Nuovo_Verso=3;
	N_Verso==3,!,Nuovo_Verso=0).

%consente di verificare la presenza di sporco nelle zone adiacenti ad (X,Y) ed eventualmente %impostare la direzione di marcia per dirigersi in quella zona.
ricerca_sporco(X,Y,Verso,N_Verso):-
	X1 is X + 1, X2 is X - 1,
	Y1 is Y + 1, Y2 is Y - 1,
	(rd_sporco(X,Y1),!,N_Verso=0;
	rd_sporco(X1,Y),!,N_Verso=1;
	rd_sporco(X,Y2),!,N_Verso=2;
	rd_sporco(X2,Y),!,N_Verso=3;
	N_Verso=Verso).

%verifica la presenza di sporco nella zona indicata
rd_sporco(X,Y):-
	stanza ? rdp(sporco(X,Y)).

%consente di attendere che si liberi la zona antestante la porta
attendi_spostamento:-
	stanza ? rd(porta(X,Y)),
	mappa ? rdp(posizione_1(Z,K)),
	((X\==Z;Y\==K);attendi_spostamento).	