%Questo agente attende che sia individuato lo sporco dall'agente "trova sporco" dopo di che 
% in grado di raggiungere lo sporco e pulire la zona. Le zone sporche sono quindi degli %obiettivi e l'agente seleziona di volta in volta quello a lui pi vicino fino %all'eliminazione completa dello sporco.

:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(ingresso).
ingresso :-
	enter_context([agent_id(pulitore_TL1)]),
	mappa ? rd(sporco_trovato),	%attende la fine del lavoro dell'ag. "trova_sporco"
	stanza ? rd(porta(X,Y)),
	(mappa ? rdp(posizione_TL2(Z,K)),!,attendi_spostamento,
	mappa ? out(posizione_TL1(X,Y));
	mappa ? out(posizione_TL1(X,Y))),
	write(posizione_TL1(X,Y)),nl,
	(sporco,!,pulisci;mappa ? out(nulla_da_pulire),write(nulla_da_pulire),nl),
	mappa ? out(fine_TL1),
	write(fine_TL1),nl,
	exit_context.

%Consente la pulizia delle zone sporche
pulisci:-
	(mappa ? rdp(posizione_TL2(D,E)),mappa ? rd(obiettivo_TL2(F,G)),
	mappa ? rdp(posizione_TL1(X,Y));mappa ? rdp(posizione_TL1(X,Y))),
	mappa ? rdp(posizione_TL1(X,Y)),
	mappa ? rdp(conta_sporco(S)),
	mappa ? inp(sporco(A1,B1)),
	(S>1,!,sporco_vicino(A1,B1);R1=A1,R2=B1,
	(mappa ? inp(obiettivo_TL1(H,K)),mappa ? out(obiettivo_TL1(R1,R2)),
	write(obiettivo_TL1(R1,R2)),nl;
	mappa ? out(obiettivo_TL1(R1,R2))),write(obiettivo_TL1(R1,R2)),nl),
	S1 is S-1,
	mappa ? inp(conta_sporco(C)),
	mappa ? out(conta_sporco(S1)),
	raggiungi_obiettivo,
	(mappa ? inp(stop_TL1),!;sporco,!,pulisci;
	mappa ? out(sporco_eliminato),write(sporco_eliminato),nl).

%Individua la zona sporca pi vicina alla posizione dell'agente 
sporco_vicino(A1,B1):-
	mappa ? rdp(posizione_TL1(X,Y)),
	mappa ? inp(sporco(A2,B2)),
	vicinanza(X,Y,A1,B1,A2,B2,R),
	(R==1,!,mappa ? out(sporco(A2,B2)),R1=A1,R2=B1;
	R==2,!,mappa ? out(sporco(A1,B1)),R1=A2,R2=B2),
	mappa ? rdp(conta_sporco(C)),
	(C==0,!,
	(mappa ? inp(obiettivo_TL1(H,K)),mappa ? out(obiettivo_TL1(R1,R2)),
	write(obiettivo_TL1(R1,R2)),nl;
	mappa ? out(obiettivo_TL1(R1,R2)),write(obiettivo_TL1(R1,R2)),nl);
	sporco_vicino(R1,R2)).

%Consente di raggiungere l'obiettivo indicato nella mappa 
raggiungi_obiettivo:-
	mappa ? rd(obiettivo_TL1(A,B)),
	mappa ? rd(posizione_TL1(X,Y)),
	(B>Y,Verso=0,!;
	A>X,Verso=1,!;
	B<Y,Verso=2,!;
	A<X,Verso=3,!;
	Obiettivo_Raggiunto=1),
	(Obiettivo_Raggiunto==1,
	mappa ? out(obiettivo_raggiunto(X,Y)),write(obiettivo_raggiunto(A,B)),nl,
	stanza ? out(pulito(X,Y));
	(mappa ? rdp(stop_TL1),!;movimento(Verso),raggiungi_obiettivo)).

%Come l'agente "pulitore_1" si muove evitando gli ostacoli
movimento(Verso) :-
	mappa ? rd(posizione_TL1(X,Y)),
	(Verso==0,!,X1=X,Y1 is Y + 1;
	Verso==1,!,X1 is X + 1,Y1=Y;
	Verso==2,!,X1=X,Y1 is Y - 1;
	Verso==3,!,X1 is X - 1,Y1=Y),
	ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso),
	(Ost==0,!,
	mappa ? out(pulito_da_TL1(X,Y)),
	stanza ? out(pulito(X,Y)),
	mappa ? in(posizione_TL1(X,Y)),
	mappa ? out(posizione_TL1(X1,Y1)),
	write(posizione_TL1(X1,Y1)),nl;
	Ost==1,movimento(Nuovo_Verso)).

ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso) :-
	((stanza ? rdp(oggetto_fisso(X1,Y1)),!,mappa ? out(oggetto_fisso_TL1(X1,Y1));
	stanza ? inp(muro(X1,Y1)),!,mappa ? out(oggetto_fisso_TL1(X1,Y1));
	altri_pulitori(X1,Y1)),
	gira(Verso,Nuovo_Verso),
	Ost=1;
	Ost=0,Nuovo_Verso=Verso).

altri_pulitori(X1,Y1):-
	(mappa ? rdp(posizione_1(X1,Y1)),!,mappa ? out(pulitore_1_in(X1,Y1));
	mappa ? rdp(posizione_2(X1,Y1)),!,mappa ? out(pulitore_2_in(X1,Y1));
	mappa ? rdp(posizione_SL1(X1,Y1)),!,mappa ? out(pulitore_SL1_in(X1,Y1));
	mappa ? rdp(posizione_TL2(X1,Y1)),!,mappa ? out(pulitore_TL2_in(X1,Y1));
	mappa ? rdp(posizione_TS(X1,Y1)),!,mappa ? out(trova_sporco_TS_in(X1,Y1))).

gira(Verso,Nuovo_Verso) :-
	(Verso==0,!,Nuovo_Verso=1;
	Verso==1,!,Nuovo_Verso=2;
	Verso==2,!,Nuovo_Verso=3;
	Verso==3,!,Nuovo_Verso=0).

%Algoritmo che calcola la distanza degli obiettivi ed individua il pi vicino
vicinanza(X,Y,A1,B1,A2,B2,R):-
	P11 is abs(A1-X),
	P12 is abs(B1-Y),
	S1 is P11 + P12,
	P21 is abs(A2-X),
	P22 is abs(B2-Y),
	S2 is P21 + P22,
	(S1>S2,!,R=2;R=1).

%controllo la presenza di sporco
sporco:-
	mappa ? rdp(sporco(X,Y)).

%consente di attendere che si liberi la zona antestante la porta
attendi_spostamento:-
	stanza ? rd(porta(X,Y)),
	mappa ? rdp(posizione_TL2(Z,K)),
	((X\==Z;Y\==K);attendi_spostamento).	