%Questo agente ha il compito di trovare lo sporco all'interno della stanza
%e segnalarlo nella mappa degli agenti

:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(ingresso).
ingresso :-
	enter_context([agent_id(trova_sporco)]),
	text_from_file('specification\pulitori.pl',T),
	mappa ? set_spec(T),
	stanza ? rd(porta(A,B)),
	mappa ? out(posizione_TS(A,B)),
	write(posizione_TS(A,B)),nl,
	mappa ? out(conta_sporco(0)),
	Verso=0,
	movimento(Verso),
	mappa ? out(sporco_trovato),	%comunica di avere finito il lavoro
	write(sporco_trovato),nl,
	exit_context.

%Come l'agente "pulitore_1" si muove evitando gli ostacoli ma a differenza di questo 
%ha l'obiettivo di individuare lo sporco, quindi si muove in diagonale per massimizzare
%la ricerca
movimento(Verso) :-
	mappa ? rd(posizione_TS(X,Y)),
	trova_sporco(X,Y),		%richiama la ricerca dello sporco
	(Verso==0,!,X1=X,Y1 is Y + 1;
	Verso==1,!,X1 is X + 1,Y1=Y;
	Verso==2,!,X1=X,Y1 is Y - 1;
	Verso==3,!,X1 is X - 1,Y1=Y),
	ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso),
	(Ost==0,!,
	mappa ? in(posizione_TS(X,Y)),
	mappa ? out(posizione_TS(X1,Y1)),
	write(posizione_TS(X1,Y1)),nl;
	Ost==1),
	(mappa ? inp(stop_TS),!;mappa ? inp(muro(X1,Y1)),!;movimento(Nuovo_Verso)).

ostacolo(X1,Y1,Verso,Ost,Nuovo_Verso) :-
	((stanza ? rdp(oggetto_fisso(X1,Y1)),!;
	stanza ? inp(muro(X1,Y1)),mappa ? out(muro(X1,Y1)),!;
	mappa ? rdp(posizione_2(X1,Y1)),!,mappa ? out(pulitore_2_in(X1,Y1))),
	gira(Verso,Nuovo_Verso),
	Ost=1;
	Ost=0,
	(Verso==0,!,Nuovo_Verso=1;	%consente il movimento diagonale
	Verso==1,!,Nuovo_Verso=0;
	Verso==2,!,Nuovo_Verso=3;
	Verso==3,!,Nuovo_Verso=2)).

gira(Verso,Nuovo_Verso) :-
	(Verso==0,!,Nuovo_Verso=1;
	Verso==1,!,Nuovo_Verso=2;
	Verso==2,!,Nuovo_Verso=3;
	Verso==3,!,Nuovo_Verso=0).

%Permette di individuare lo sporco nelle lungo le 4 direzioni (+/-Y e +/-X) se non ci sono
%ostacoli che ostruiscono la visibilit
trova_sporco(X,Y):-
	su_Y(X,Y),
	giu_Y(X,Y),
	su_X(X,Y),
	giu_X(X,Y).
	
su_Y(A,B):-
	(not ostacolo(A,B),not rd_sporco(A,B),B1 is B+1,su_Y(A,B1),!;
	rd_sporco(A,B),!,mappa ? out(sporco(A,B)),write(sporco(A,B)),nl,
	B1 is B+1,su_Y(A,B1),!;ostacolo(A,B)).

giu_Y(A,B):-
	(not ostacolo(A,B),not rd_sporco(A,B),B1 is B-1,giu_Y(A,B1),!;
	rd_sporco(A,B),!,mappa ? out(sporco(A,B)),write(sporco(A,B)),nl,
	B1 is B-1,giu_Y(A,B1),!;ostacolo(A,B)).

su_X(A,B):-
	(not ostacolo(A,B),not rd_sporco(A,B),A1 is A+1,su_X(A1,B),!;
	rd_sporco(A,B),!,mappa ? out(sporco(A,B)),write(sporco(A,B)),nl,
	A1 is A+1,su_X(A1,B),!;ostacolo(A,B)).
	
giu_X(A,B):-
	(not ostacolo(A,B),not rd_sporco(A,B),A1 is A-1,giu_X(A1,B),!;
	rd_sporco(A,B),!,mappa ? out(sporco(A,B)),write(sporco(A,B)),nl,
	A1 is A-1,giu_Y(A1,B),!;ostacolo(A,B)).

%ostacoli che impediscono la visibilit
ostacolo(X,Y) :-
	(stanza ? rdp(oggetto_fisso(X,Y)),!;
	stanza ? inp(muro(X,Y))).

%controlla la presenza di sporco alle coordinate specificate
rd_sporco(X,Y):-
	stanza ? rdp(sporco(X,Y)).